<!--- we need this proxy for add/delete calls to the CFC--->
<cfajaxproxy cfc="data" jsclassname="cfcproxy">
<html>
<head>
<script type="text/javascript" src="/CFIDE/scripts/ajax/ext/package/toolbar/toolbar.js"></script>
<script type="text/javascript">
// create a new JS proxy object for the CFC	
var dataproxy = new cfcproxy();
dataproxy.setCallbackHandler(handleResult);

// this function recieves the response from CFC whenever a CFC function is called.
// we are simply alerting the response but we could do more if we had to. 
function handleResult(response)
{
	alert(response);
}

// the init()
function init(){
 grid = ColdFusion.Grid.getGridObject("ArtistGrid");
 
 // get the header and fotoer objects
 var gridHead = grid.getView().getHeaderPanel(true);
 var tbar = new Ext.Toolbar(gridHead);
 var gridFoot = grid.getView().getFooterPanel(true);
 var ds = grid.getDataSource();
 
 // add the 2 custom buttons to the toolbar
 tbar.addButton({text:"Add Artist", handler:onAdd });
 tbar.addSeparator();
 tbar.addButton({ text:"Delete Artist", handler:onDelete });
 
 // add a row double click event for the grid rows.
 // the double click will open a popup window for editing the row.
 var sm = grid.getSelectionModel();
 grid.on('rowdblclick',function(grid, rowIndex, record){
 	var rec = ds.getAt(rowIndex); // get the clicked row
	populateForm(rec); // populate the form with values
 	ColdFusion.Window.show('addArtistWin'); // display the window
 });
 
  // this shows the display message by default 
 var paging = new Ext.PagingToolbar(gridFoot,ds,{
	  pageSize:10, //number of records displayed in grid
	  displayInfo:true, // change this to false, if you dont want info displayed
	  displayMsg:'Displaying records {0} - {1} of {2}',
	   emptyMsg:"No records to display"
	   });
	   
// add a custom combobox to the grid header - this combobox lets you choose the number of rows you want to see
 cb = new Ext.form.ComboBox({
   id:"pagingCombo",
   emptyText:"Rows per page",
   mode:"local",
   triggerAction:"all",
   displayField:"text",
   valueField:"value",
         store:new Ext.data.SimpleStore({
            fields: ["value", "text"],
            data: [
               ["5","5 rows per page"],
               ["10","10 rows per page"],
               ["15","15 rows per page"],
               ["20","20 rows per page"]
            ]
   })
});

// add event listener to combobox
// this code will update the grid pageSize 
cb.addListener("select",function(combo,record,index){
// the new pageSize from combobox -  it needs to have parseInt() else it starts acting weird
 var numRows = parseInt(record.data.value);
 paging.pageSize = parseInt(numRows);
 paging.onClick("refresh");
});

// add the paging combo to right side of the toolbar      
Ext.fly(tbar.addSpacer().getEl().parentNode).setStyle('width', '100%');
tbar.add(cb);	   
	   
}

function populateForm(record){
	// gets the selected row from double click event and populates the form 
	// could also use ColdFusion.getElementValue() here which gets the bound grid row but I find this method better
	
	// the form
	var frm = document.forms["frmArtist"];
	
	// default values if using the "add artist" mode
	var fname = "dummy";
	var lname= "dummy";
	var email = "dummy@dummy.com";
	var address = "dummy";
	var city = "dummy";
	var state = "CA";
	var postalcode=  "754";
	var artistid = "0";
	var btntext = "Add Artist";
	
	if(record)
	{
		// values for the selected row 
		if(record.data.FIRSTNAME.length != 0) fname = record.data.FIRSTNAME;
		if(record.data.LASTNAME.length != 0) lname = record.data.LASTNAME;
		if(record.data.EMAIL.length != 0) email = record.data.EMAIL;
		if(record.data.ADDRESS.length != 0) address = record.data.ADDRESS;
		if(record.data.CITY.length != 0) city = record.data.CITY;
		if(record.data.STATE.length != 0) state = record.data.STATE;
		if(record.data.POSTALCODE.length != 0) postalcode = record.data.POSTALCODE;
		if(record.data.ARTISTID != '0') artistid = record.data.ARTISTID; 
		if(record.data.ARTISTID != '0') ; btntext = "Update Artist";
	}
	//populate the form, finally
	frm.artistid.value = artistid;
 	frm.txtFirstName.value = fname;
	frm.txtLastName.value = lname;
	frm.txtEmail.value = email;
	frm.txtAddress.value = address;
	frm.txtCity.value = city;
	frm.txtPostalCode.value= postalcode;
	frm.txtState.value = state;
	frm.artistid.value = artistid;   
	frm.btnAction.value = btntext;
}

function onAdd(button,event){
	populateForm(false);
	ColdFusion.Window.show('addArtistWin');
}
function onDelete(){
	ColdFusion.Window.show('deleteArtistWin');
}

function saveartist()
{
	//send data to CFC to add artist, the result will be handled by handleResult function above
	var f = document.frmArtist;
	dataproxy.saveArtist(
		 f.artistid.value
		,f.txtFirstName.value
		,f.txtLastName.value
		,f.txtEmail.value
		,f.txtAddress.value
		,f.txtCity.value
		,f.txtState.value
		,f.txtPostalCode.value
	);
	ColdFusion.Grid.refresh('ArtistGrid', true);	
	ColdFusion.Window.hide('addArtistWin');
}

function deleteArtist(s)
{
	// if user choose to delete, then send the CFC call, otherwise just sit back!
	if (s == 'yes')
	{
	var grid = ColdFusion.Grid.getGridObject("ArtistGrid");
	var record = grid.getSelections();
	// remember, CF makes column names to all UPPERCASE, so dont forget to do that
	dataproxy.deleteArtist(record[0].data.ARTISTID);
	}
	ColdFusion.Grid.refresh('ArtistGrid', true);
	ColdFusion.Window.hide('deleteArtistWin');
}


</script>
</head>



<cfset args = structNew()>
<cfset args.name = "ArtistGrid">
<cfset args.format = "html">
<cfset args.bindOnLoad = "true">
<cfset args.bind = "cfc:data.getArtists({cfgridpage},{cfgridpagesize},
            {cfgridsortcolumn},{cfgridsortdirection})">
<cfset args.stripeRows = true>
<cfset args.selectColor = "##D9E8FB">
<!--- <cfset args.selectmode = "edit"> --->
<!--- <cfset args.onchange = "cfc:data.editArtist({cfgridaction},{cfgridrow},{cfgridchanged})">  --->

<cfform>
<cfgrid attributeCollection="#args#">
	<cfgridcolumn name="artistid" display="false">
	<cfgridcolumn name="firstname" header="First Name">
	<cfgridcolumn name="lastname" header="Last Name">
	<cfgridcolumn name="email" header="Email Address">
	<cfgridcolumn name="address" header="Address">
	<cfgridcolumn name="city" header="City" display="false">
	<cfgridcolumn name="state" header="State" display="false">
	<cfgridcolumn name="postalcode" header="Zip" display="false">
</cfgrid>
</cfform>

<cfwindow width="150" height="150" name="deleteArtistWin" modal="true" resizable="false" title="Delete Artist?"
bodyStyle="font-family: verdana; color: ##000000;font-size:15px;font-weight:bold;"
       headerStyle="font-family: verdana; background-color: black; color: white">
	<div style="margin-left:5px;margin-top:5px;">
	Please Confirm this action.
	<input type="button" value="yes, surely!" onClick="deleteArtist('yes')">
	<input type="button" value="no, please! " onClick="deleteArtist('no')">
	<br/>
	
</cfwindow>

<cfwindow name="addArtistWin" modal="true" resizable="false" title="Add New Artist" bodyStyle="font-size:10px;font-family: verdana; color: ##ff0000;"
       headerStyle="font-family: verdana; background-color: black; color: white">
	<cfform name="frmArtist" style="font-size:10px;">
    <input type="hidden" name="artistid" value="0" />
		<table width="100%">
			<tr>
				<td>Firstname</td>
				<td><cfinput type="text" name="txtFirstName" value="dummy"></td>
			</tr>
			<tr>
				<td>Lastname</td>
				<td><input type="text" name="txtLastName"  value="dummy"></td>
			</tr>
			<tr>
				<td>Email</td>
				<td><input type="text" name="txtEmail"  value="dummy"></td>
			</tr>
			<tr>
				<td>Address</td>
				<td><input type="text" name="txtAddress"  value="dummy"></td>
			</tr>
			<tr>
				<td>City</td>
				<td><input type="text" name="txtCity"  value="CA"></td>
			</tr>
			<tr>
				<td>State</td>
				<td><input type="text" name="txtState"  value="NY"></td>
			</tr>
			<tr>
				<td>postalCode</td>
				<td><input type="text" name="txtPostalCode"  value="dummy"></td>
			</tr>
			<tr>
				<td colspan="2"><input type="button" name="btnAction" value="Add Artist" onClick="javascript:saveartist();"></td>
			</tr>
	</cfform>
</cfwindow>
<cfset ajaxOnLoad("init")>

</html>